# Change Log
All notable changes to this project will be documented in this file.

## [0.7.5] - 2021-02-xx

### Added
  - `Ecoportal::API::Common::ClassHelpers` added inheritable attribute values
  - `Ecoportal::API::V2::Pages::PageStage` added missing properties
  - `Ecoportal::API::V2::Page::Stages#ordered_stages` method to obtain stages in order
  - `Ecoportal::API::V2::Registers#search` method search pages in the register, which includes new classes:
    - `Ecoportal::API::V2::Registers::PageResult`
    - `Ecoportal::API::V2::Registers::StagesResult`
    - `Ecoportal::API::V2::Registers::StageResult`
  - `Ecoportal::API::V2::Pages#get` added parameter `stage_id:` to be able to directly obtain the stage

### Changed
  - Moved some classes to the new namespace `Ecoportal::API::V2::Registers`
    - `Ecoportal::API::V2::Registers::Register`
    - `Ecoportal::API::V2::Registers::Template`

### Fixed
  - `Ecoportal::API::Common::Content::HashDiffPatch`: `deleted` operation wording and `data.patch_ver`
  - `Ecoportal::API::V2::Page::Component.new_doc` should delegate to child classes that have their own implementation
    - `Ecoportal::API::V2::Page::Component::ImagesField.new_doc` should include `layout`
    - `Ecoportal::API::V2::Page::Component::SignatureField.new_doc` should include `color`

## [0.7.4] - 2021-02-12

### Added
  - `Ecoportal::API::V2::Page::Component::GaugeStop#color=` enabled setting colours using a `symbol`
    - `:blue`, `:blue_greyed`, `:blue_light`
    - `:turquoise`, `:jade`, `:green`, `:pistachio`, `:avocado`
    - `:yellow`, `:orange`, `:pumpkin`, `:red`, `:magenta`, `:fuchsia`, `:purple`, `:violet`
  - `Ecoportal::API::V2::Page::Component::GaugeStop#color_sym` to get the color as `symbol` name
  - added support for chart fields:
    - `Ecoportal::API::V2::Page::Component::ChartField` with the different `mode` types
    - `Ecoportal::API::V2::Page::Component::ChartFrField` (LTIFR)

### Changed
  - `Ecoportal::API::Page::Component::DateField` Date objects + Timezones
    - `#value` should be shown in local time
    - `#value=` should be set by local time
  - `Ecoportal::API::Common::Content::DoubleModel.embeds_multiple` renamed to `embeds_many`
  - `Ecoportal::API::Common::Content::DoubleModel.embeds_one` removed parameter `:multiple`
  - Fields under `Ecoportal::API::Page::Component` that `embeds_many` should generate new elements in a standard way
    - added `Ecoportal::API::Common::Content::CollectionModel#items_class` method

### Fixed
  - solved `pretty_print` name collision renaming to `Ecoportal::API::Common::Content::DoubleModel#print_pretty`

## [0.7.3] - 2021-02-01

### Added
  - `Ecoportal::API::Common::Content::CollectionModel#delete!` finally scoped how delete should work :)
  - `Ecoportal::API::V2.new` better feedback on key error.
  - `Ecoportal::API::V2::Page::Component::SignatureField` added property `signed_by_name`
  - `Ecoportal::API::V2::Page::Component#required` this field property is currently supported
  - `Ecoportal::API::V2::Page::Component::DateField` more supported properties:
    * `show_time`, `today_button`, `past_only`, `create_event`, `remind_me_in`, `renews`, `renews_every`, `renews_unit`, `renews_until`
  - `Ecoportal::API::V2::Page::Component::ChecklistField`
    * added more methods: `add_item`, `ordered_items`
  - `Ecoportal::API::V2::Page::Component::GaugeField`
    * more supported properties: `max`, `active_color` and `stops`
      - for `stops` added class `Ecoportal::API::V2::Page::Component::GaugeStop`
    * added more methods: `add_stop`, `ordered_stops`
  - `Ecoportal::API::V2::Page::Component::ReferenceField` more supported properties:
    * `register_id`, `hide_create`, `hide_attach`, `hide_metadata`, `hide_dashboards`, `display_fields`, `display_fields_in_lookup`
  - `Ecoportal::API::V2::Page::Component::ActionField`
    * more supported properties:`create_actions`, `required_number_of_completed_actions`, `permits_and_rules_integration`, `add_subscribed`, `add_subscribed_to_tasks`
    * added more methods: `add_task`, `ordered_tasks`
    - `Ecoportal::API::V2::Page::Component::Action` modified, provided that some properties are `read_only`
  - `Ecoportal::API::V2::Page::Component::PeopleField` more supported properties:
    * `is_me_button`, `attach_mode`, `person_schema_id`, `viewable_fields`, `singular`, `requires_number`, `cached_people`, `attached_people_permissions_enabled`, `apply_attached_people_permissions_to`, `attached_people_permissions_editable`, `attached_people_permissions_flags`
  - `Ecoportal::API::V2::Page::Component::PlainTextField` more supported properties:
    * `multiline`, `max_length`, `exact_index`
  - `Ecoportal::API::V2::Page::Component::SelectionField` more supported properties:
    * `flat`
  - `Ecoportal::API::V2::Page::Component::TagField` more supported properties:
    * `single_select`, `use_defaults`, `tag_tree_id`, `button_text`
  - `Ecoportal::API::V2::Page::Section` more supported properties:
    * `minimized`

### Changed
  - upgraded `ecoportal-api` dependency

### Fixed
  - `Ecoportal::API::Common::Content::CollectionModel#upsert!` was not actually moving the element to the new position when it already existed

## [0.7.2] - 2020-10-07

### Added
  - automatic key builder
    - helper: `Ecoportal::API::V2::v2key` method
    - `user_key:` and `org_key:` as constructor methods for `Ecoportal::API::V2`
### Changed
### Fixed

## [0.7.1] - 2020-10-07

### Added
### Changed
  - updated dependencies
### Fixed


## [0.7.0] - 2020-09-10

### Added
### Changed
  - updated dependencies
### Fixed

## [0.6.1] - 2020-07-11

### Added
  - `Ecoportal::API::Common::Content::DoubleModel#pretty_print`
### Changed
### Fixed

## [0.6.0] - 2020-07-11

### Added
### Changed
  - upgraded `ecoportal-api` gem
### Fixed

## [0.5.9] - 2020-07-02

### Added
  - helper `Ecoportal::API::Common::Content::StringDigest#indexable_label`: to see the part of a label that gets indexed
  - this `CHANGELOG.md` file
### Changed
### Fixed
